<?php
error_reporting(0);

class ControllerExtensionPaymentIsposPayment extends Controller
{

    private $error = array();
    private $base_url = "";
    private $order_prefix = "opencart30X_";
    private $module_version = "3.0.0.0";

    public function index()
    {

        $this->language->load('extension/payment/ispos_payment');
        $this->load->model('extension/payment/ispos_payment');
        $this->document->setTitle($this->language->get('heading_title'));
        include DIR_SYSTEM . 'library/ispos-payment/class-kahvedigital_isposconfig.php';
        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_ispos_payment', $this->request->post);
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_edit'] = $this->language->get('heading_title');
        $data['link_title'] = $this->language->get('text_link');

        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');

        $data['ispos_merchant_id'] = $this->language->get('ispos_merchant_id');
        $data['ispos_user_id'] = $this->language->get('ispos_user_id');
        $data['ispos_api_key'] = $this->language->get('ispos_api_key');

        $data['entry_installement'] = $this->language->get('entry_installement');

        $data['entry_order_status'] = $this->language->get('entry_order_status');
        $data['entry_status'] = $this->language->get('entry_status');
        $data['entry_threed'] = $this->language->get('entry_threed');
        $data['entry_class_responsive'] = $this->language->get('entry_class_responsive');
        $data['entry_class_popup'] = $this->language->get('entry_class_popup');
        $data['entry_installment_options'] = $this->language->get('entry_installment_options');
        $data['entry_sort_order'] = $this->language->get('entry_sort_order');
        $data['entry_ispos_test_mode'] = $this->language->get('entry_ispos_test_mode');

        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['order_status_after_payment_tooltip'] = $this->language->get('order_status_after_payment_tooltip');
        $data['order_status_after_cancel_tooltip'] = $this->language->get('order_status_after_cancel_tooltip');
        $data['entry_test_tooltip'] = $this->language->get('entry_test_tooltip');
        $data['entry_cancel_order_status'] = $this->language->get('entry_cancel_order_status');

        $data['message'] = '';
        $data['error_warning'] = '';
        $data['error_version'] = '';

        $error_data_array_key = array(
            'merchant_id',
            'user_id',
            'api_key',
        );

        if ($this->config->get('payment_ispos_payment_rates') == null) {

            $this->config->set('payment_ispos_payment_rates', KahveDigitalIspos::setRatesDefault());

        }

        if (isset($this->request->get['update_error'])) {
            $data['error_version'] = $this->language->get('entry_error_version_updated');
        } else {
            $this->load->model('extension/payment/ispos_payment');
            $versionCheck = $this->model_extension_payment_ispos_payment->versionCheck(VERSION, $this->module_version);

            if (!empty($versionCheck['version_status']) and $versionCheck['version_status'] == '1') {
                $data['error_version'] = $this->language->get('entry_error_version');
                $data['ispos_or_text'] = $this->language->get('entry_ispos_or_text');
                $data['ispos_update_button'] = $this->language->get('entry_ispos_update_button');
                $version_updatable = $versionCheck['new_version_id'];
                $data['version_update_link'] = $this->url->link('extension/payment/ispos_payment/update', 'user_token=' . $this->session->data['user_token'] . "&version=$version_updatable", true);
            }
        }

        foreach ($error_data_array_key as $key) {
            $data["error_{$key}"] = isset($this->error[$key]) ? $this->error[$key] : '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home', 'user_token=' . $this->session->data['user_token'], 'SSL'),
            'separator' => false,
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_payment'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true),
            'separator' => ' :: ',
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/ispos_payment', 'user_token=' . $this->session->data['user_token'], 'SSL'),

            'separator' => ' :: ',
        );

        $data['action'] = $this->url->link('extension/payment/ispos_payment', 'user_token=' . $this->session->data['user_token'], 'SSL');

        $data['cancel'] = $this->url->link('extension/payment', 'user_token=' . $this->session->data['user_token'], 'SSL');

        $merchant_keys_name_array = array(
            'payment_ispos_payment_merchant_id',
            'payment_ispos_payment_user_id',
            'payment_ispos_payment_api_key',
            'payment_ispos_payment_status',
            'payment_ispos_payment_order_status_id',
            'payment_ispos_payment_sort_order',
            'payment_ispos_payment_installement',
            'payment_ispos_payment_test_mode',
            'payment_ispos_payment_rates',
            'payment_ispos_payment_cancel_order_status_id',
        );

        foreach ($merchant_keys_name_array as $key) {
            $data[$key] = isset($this->request->post[$key]) ? $this->request->post[$key] : $this->config->get($key);
        }

        $data['ispos_rates_table'] = KahveDigitalIspos::createRatesUpdateForm($this->config->get('payment_ispos_payment_rates'));
        $this->load->model('localisation/order_status');
        if ($data['payment_ispos_payment_order_status_id'] == '') {
            $data['payment_ispos_payment_order_status_id'] = $this->config->get('config_order_status_id');
        }
        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/ispos_payment', $data));

    }

    public function install()
    {
        $this->load->model('extension/payment/ispos_payment');
        $this->model_extension_payment_ispos_payment->install();
        if (!isset($this->session->data['ispos_update'])) {
            $this->load->controller('extension/modification/refresh');
        }
    }

    public function uninstall()
    {
        $this->load->model('extension/payment/ispos_payment');
        $this->model_extension_payment_ispos_payment->uninstall();
        if (!isset($this->session->data['ispos_update'])) {
            $this->load->controller('extension/modification/refresh');
        }
    }

    public function update()
    {

        $this->load->model('extension/payment/ispos_payment');
        $this->load->language('extension/payment/ispos_payment');
        $version_updatable = $this->request->get['version'];
        $updated = $this->model_extension_payment_ispos_payment->update($version_updatable);
        if ($updated == 1) {
            $this->load->model('setting/setting');
            $payment_ispos_payment_merchant_id = $this->config->get('payment_ispos_payment_merchant_id');
            $payment_ispos_payment_user_id = $this->config->get('payment_ispos_payment_user_id');
            $payment_ispos_payment_api_key = $this->config->get('payment_ispos_payment_api_key');
            $payment_ispos_payment_status = $this->config->get('payment_ispos_payment_status');
            $payment_ispos_payment_order_status_id = $this->config->get('payment_ispos_payment_order_status_id');
            $payment_ispos_payment_sort_order = $this->config->get('payment_ispos_payment_sort_order');
            $payment_ispos_payment_installement = $this->config->get('payment_ispos_payment_installement');
            $payment_ispos_payment_test_mode = $this->config->get('payment_ispos_payment_test_mode');
            $payment_ispos_payment_rates = $this->config->get('payment_ispos_payment_rates');
            $payment_ispos_payment_cancel_order_status_id = $this->config->get('payment_ispos_payment_cancel_order_status_id');

            $this->session->data['ispos_update'] = 1;
            $this->load->controller('extension/payment/' . 'ispos_payment' . '/uninstall');
            $this->load->controller('extension/payment/' . 'ispos_payment' . '/install');

            $this->config->set('payment_ispos_payment_merchant_id', $payment_ispos_payment_merchant_id);
            $this->config->set('payment_ispos_payment_user_id', $payment_ispos_payment_user_id);
            $this->config->set('payment_ispos_payment_api_key', $payment_ispos_payment_api_key);
            $this->config->set('payment_ispos_payment_status', $payment_ispos_payment_status);
            $this->config->set('payment_ispos_payment_order_status_id', $payment_ispos_payment_order_status_id);
            $this->config->set('payment_ispos_payment_sort_order', $payment_ispos_payment_sort_order);
            $this->config->set('payment_ispos_payment_installement', $payment_ispos_payment_installement);
            $this->config->set('payment_ispos_payment_test_mode', $payment_ispos_payment_test_mode);
            $this->config->set('payment_ispos_payment_rates', $payment_ispos_payment_rates);
            $this->config->set('payment_ispos_payment_cancel_order_status_id', $payment_ispos_payment_cancel_order_status_id);

            unset($this->session->data['ispos_update']);
            $this->load->controller('extension/modification/refresh');
            $this->session->data['success'] = $this->language->get('text_success');
            $this->response->redirect($this->url->link('extension/payment', 'user_token=' . $this->session->data['user_token'], 'SSL'));
        } else {
            $this->response->redirect($this->url->link('extension/payment/ispos_payment', 'user_token=' . $this->session->data['user_token'] . "&update_error=$updated", true));
        }
    }

    public function order()
    {

        $this->language->load('extension/payment/ispos_payment');
        $language_id = (int) $this->config->get('config_language_id');
        $this->data = array();
        $orderId = (int) $this->request->get['order_id'];

        if ($this->config->get('payment_ispos_payment_test_mode') == "ON") {

            $endPointUrl = 'https://apitest.isyerimpos.com/v1/' . "payResultCheck?orderId=" . $orderId;

        } else {

            $endPointUrl = "https://api.isyerimpos.com/v1/" . "payResultCheck?orderId=" . $orderId;

        }

        $merchantId = $this->config->get('payment_ispos_payment_merchant_id');
        $userId = $this->config->get('payment_ispos_payment_user_id');
        $apiKey = $this->config->get('payment_ispos_payment_api_key');

        $response = $this->curlPostExt(json_encode($arrayToRequest), $endPointUrl, true, $merchantId, $userId, $apiKey);

        $response = json_decode($response, true);

        $amount = $response['Content']['NetAmount'];
        $amount = number_format($amount, 2, '.', '');

        $message = 'Payment ID: ' . $orderId . "\n";
        $message .= 'Ödeme Net Tuttar  : ' . $amount;

        $data['user_token'] = $this->request->get['user_token'];
        $data['heading_title'] = $this->language->get('heading_title');
        $data['text_isposPaymentId'] = $this->language->get('text_isposPaymentId');
        $data['text_sepet_total'] = $this->language->get('text_sepet_total');
        $data['text_odenen'] = $this->language->get('text_odenen');
        $data['text_komisyon'] = $this->language->get('text_komisyon');
        $data['text_taksit_sayi'] = $this->language->get("text_taksit_sayi");
        $data['text_creditcart'] = $this->language->get('text_creditcart');
        $data['text_rescode'] = $this->language->get('text_rescode');

        $data['isposPaymentId'] = $response['Content']['Uid'];
        $data['sepet_total'] = $response['Content']['NetAmount'] + $response['Content']['FmCostAmount'];
        $data['taksit_sayi'] = $response['Content']['Installment'];
        $data['komisyon'] = $response['Content']['FmCostAmount'];
        $data['creditcart'] = $response['Content']['CardInfo']['CardNo'];
        return $this->load->view('extension/payment/ispos_payment_order', $data);
    }

    private function curlPostExt($data = null, $url, $json = false, $merchantId, $userId, $apiKey)
    {
        $ch = curl_init(); // initialize curl handle
        curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // return into a variable

        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30); // times out after 4s
        curl_setopt($ch, CURLOPT_POST, 1); // set POST method
        if ($data !== null) {
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // add POST fields
        }
        $headers = array(
            "MerchantId:  $merchantId",
            "UserId:  $userId",
            "ApiKey:  $apiKey",
            "Content-Type: application/json",
        );
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        if ($result = curl_exec($ch)) { // run the whole process
            curl_close($ch);

            return $result;
        }
    }
    protected function validate()
    {
        if (!$this->user->hasPermission('modify', 'extension/payment/ispos_payment')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        $validation_array = array(
            'merchant_id',
            'user_id',
            'api_key',
        );

        foreach ($validation_array as $key) {
            if (empty($this->request->post["payment_ispos_payment_{$key}"])) {
                $this->error[$key] = $this->language->get("error_$key");
            }
        }

        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    }

    private function _addhistory($order_id, $order_status_id, $comment)
    {

        $this->load->model('sale/order');
        $this->model_sale_order->addOrderHistory($order_id, array(
            'order_status_id' => $order_status_id,
            'notify' => 1,
            'comment' => $comment,
        ));

        return true;
    }

}