<?php
error_reporting(0);
// error_reporting(E_ALL);
// ini_set("display_errors", 1);

class ControllerExtensionPaymentIsposPayment extends Controller
{

    private $order_prefix = "opencart30X_";

    public function index()
    {

        $this->language->load('extension/payment/ispos_payment');
        $this->load->model('extension/payment/ispos_payment');
        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $cart_total_amount = round($order_info['total'] * $order_info['currency_value'], 2);

        $data['cart_total'] = $cart_total_amount;
        $data['code'] = $this->language->get('code');
        $data['text_credit_card'] = $this->language->get('text_credit_card');
        $data['text_wait'] = $this->language->get('text_wait');
        //form
        $data['text_payment_form'] = $this->language->get('text_payment_form');
        $data['text_payment_form_onepay'] = $this->language->get('text_payment_form_onepay');
        $data['text_card_name'] = $this->language->get('text_card_name');
        $data['text_card_number'] = $this->language->get('text_card_number');
        $data['text_card_aagg'] = $this->language->get('text_card_aagg');
        $data['text_payment_form_installement_options'] = $this->language->get('text_payment_form_installement_options');
        $data['text_payment_form_installement'] = $this->language->get('text_payment_form_installement');
        $data['text_payment_form_pay'] = $this->language->get('text_payment_form_pay');

        $data['button_confirm'] = $this->language->get('button_confirm');
        $data['continue'] = $this->url->link('checkout/success');
        $data['error_page'] = $this->url->link('checkout/error');

        $validform = md5($order_info['order_id'] . $order_info['store_url']);
        $data['validform'] = $validform;

        if (!isset($this->session->data['order_id']) or !$this->session->data['order_id']) {
            die('Sipariş ID bulunamadı');
        }
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $data['orderid'] = $this->session->data['order_id'];
        $record = array('result_code' => false, 'result_message' => false);
        $validform = md5($order_info['order_id'] . $order_info['store_url']);

        if (isset($this->request->post['validform']) && $this->request->post['validform'] == $validform) {

            $record = $this->PostIsposForm();
        } 

        include DIR_SYSTEM . 'library/ispos-payment/class-kahvedigital_isposconfig.php';

        $total_cart = round($order_info['total'] * $order_info['currency_value'], 2);
        $ispos_rates = KahveDigitalIspos::calculatePrices($total_cart, $this->config->get('payment_ispos_payment_rates'));

        $data['installments_mode'] = $this->config->get('payment_ispos_payment_installement');
        $data['rates'] = $ispos_rates;
        $data['showtotal'] = $total_cart . ' ' . $order_info['currency_code'];

        $data['action'] = $this->url->link('extension/payment/ispos_payment', '', 'SSL');
        $data['actionBin'] = $this->url->link('extension/payment/ispos_payment/BinCheck', '', 'SSL');

        if (VERSION >= '2.2.0.0') {
            $template_url = 'extension/payment/ispos_payment';
        } else {
            $template_url = 'default/template/extension/payment/ispos_payment';
        }
        return $this->load->view($template_url, $data);

    }
    public function returncheck()
    {
        $this->CheckOrderIspos($this->session->data['order_id'], $this->request->post);

    }

    

    private function setcookieSameSite($name, $value, $expire, $path, $domain, $secure, $httponly)
    {

        if (PHP_VERSION_ID < 70300) {

            setcookie($name, $value, $expire, "$path; samesite=None", $domain, $secure, $httponly);
        } else {
            setcookie($name, $value, [
                'expires' => $expire,
                'path' => $path,
                'domain' => $domain,
                'samesite' => 'None',
                'secure' => $secure,
                'httponly' => $httponly,
            ]);

        }
    }

    public function CheckOrderIspos($orderId, $Post)
    {
        $this->load->model('checkout/order');
        $arrayToRequest = array(
    
        );

        if ($this->config->get('payment_ispos_payment_test_mode') == "ON") {

            $endPointUrl = 'https://apitest.isyerimpos.com/v1/' . "payResultCheck?orderId=" . $orderId;

        } else {

            $endPointUrl = "https://api.isyerimpos.com/v1/" . "payResultCheck?orderId=" . $orderId;

        }

        $merchantId = $this->config->get('payment_ispos_payment_merchant_id');
        $userId = $this->config->get('payment_ispos_payment_user_id');
        $apiKey = $this->config->get('payment_ispos_payment_api_key');

        $response = $this->curlPostExt(json_encode($arrayToRequest), $endPointUrl, true, $merchantId, $userId, $apiKey);
        $response = json_decode($response, true);

        if ($response['Content']['Status'] == 4) {

            $amount = $response['Content']['NetAmount'];
            $amount = number_format($amount, 2, '.', '');

            $message = 'Payment ID: ' . $orderId . "\n";
            $message .= 'Ödeme Net Tuttar  : ' . $amount;
            $this->session->data['payment_method']['code'] = 'ispos_payment';
            $this->model_checkout_order->addOrderHistory($orderId, $this->config->get('payment_ispos_payment_order_status_id'), $message, false);
            $this->response->redirect($this->url->link('checkout/success', '', 'SSL'));
        } else {

            $this->session->data['error'] = $response['Message'];
            $this->response->redirect($this->url->link('checkout/checkout', '', 'SSL'));

        }

    }

    public function PostIsposForm()
    {

        include DIR_SYSTEM . 'library/ispos-payment/class-kahvedigital_isposconfig.php';

        $sessionKey = "PHPSESSID";
        $sessionValue = $_COOKIE['PHPSESSID'];
        $setCookie = $this->setcookieSameSite($sessionKey, $sessionValue, time() + 86400, "/", $_SERVER['SERVER_NAME'], true, true);

        $sessionKey = "OCSESSID";
        $sessionValue = $_COOKIE['OCSESSID'];
        $setCookie = $this->setcookieSameSite($sessionKey, $sessionValue, time() + 86400, "/", $_SERVER['SERVER_NAME'], true, true);

        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        $record = array(
            'result_code' => '0',
            'result_message' => '',
            'result' => false,
        );

        $total = $this->request->post['ispostotal'];

        $name = $this->request->post['card-name'];
        $number = $this->request->post['number'];
        $expiry = $this->request->post['expiry'];
        $cvc = $this->request->post['cvc'];
        $total = $_POST['ispostotal'];

        $expiry = explode("/", $expiry);
        $expiryMM = $expiry[0];
        $expiryYY = $expiry[1];
        $expiryMM = $this->replaceSpace($expiryMM);
        $expiryYY = $this->replaceSpace($expiryYY);
        $number = $this->replaceSpace($number);

        if (is_array($total)) {
            $bankalar = KahveDigitalIspos::getAvailablePrograms();
            foreach ($bankalar as $key => $value) {

                $isim = $key;
                for ($x = 1; $x <= 12; $x++) {

                    $taksit = $total[$key][$x];
                    if (!empty($taksit)) {
                        $installement = $x;

                        $paid = $taksit;
                    }
                }
            }
        }
        if (empty($paid)) {
            $taksit = $total;
            $paid = $taksit;
            $installement = 1;
        }
        $paid = number_format($paid, 2, '.', '');
        $orderid = $this->session->data['order_id'];

        $products = $this->cart->getProducts();
        foreach ($products as $key => $product) {

            $price = $product['total'] * $order_info['currency_value'];
            $price = number_format($price, 2, '.', '');
            $basketItems[$keyNumber] = array();

            $basketItems[$keyNumber]['Name'] = $product['name'];
            $basketItems[$keyNumber]['UnitPrice'] = $price;
            $basketItems[$keyNumber]['Count'] = $product['quantity'];

            $keyNumber++;

        }

        if ($this->config->get('payment_ispos_payment_test_mode') == "ON") {
            $endPointUrl = "https://apitest.isyerimpos.com/v1/" . "payRequest3d";
        } else {
            $endPointUrl = "https://api.isyerimpos.com/v1/" . "payRequest3d";
        }

        $merchantId = $this->config->get('payment_ispos_payment_merchant_id');
        $userId = $this->config->get('payment_ispos_payment_user_id');
        $apiKey = $this->config->get('payment_ispos_payment_api_key');

        $arrayToRequest = array(
            "ReturnUrl" => $this->url->link('extension/payment/ispos_payment/returncheck', '', 'SSL'),
            "OrderId" => $orderid,
            "ClientIp" => $this->get_the_user_ip(),
            "Installment" => $installement,
            "Amount" => $paid,
            // "ReflectCost" => 1,
            "CardInfo" => array(
                "CardOwner" => $name,
                "CardNo" => $number,
                "Month" => $expiryMM,
                "Year" => $expiryYY,
                "Cvv" => $cvc,

            ),
            "CustomerInfo" => array(
                "Name" => $order_info['firstname'] . ' ' . $order_info['lastname'],
                "Phone" => '5072810501',
                "Email" => $order_info['email'],
                "Address" => $order_info['payment_address'],
                "Description" => '0000000',

            ),
            "Products" => $basketItems,

        );

        $response = $this->curlPostExt(json_encode($arrayToRequest), $endPointUrl, true, $merchantId, $userId, $apiKey);

        $respo = json_decode($response, true);

        if ($respo['IsDone'] == true) {

            print_r($respo['Content']['ResponseAsHtml']);
        } else {

            $message = $respo['Message'];//$xmlToarray["responseMessage"];
            $message = !empty($message) ? $message : "Invalid Request";
            $this->session->data['error'] = $message;

            $this->response->redirect($this->url->link('checkout/checkout', '', 'SSL'));
        }

    }

    public function BinCheck()
    {

        if (empty($_POST["BinNumber"])) {
            die();
        }
        $arrayToRequest = array(
            "CardNumber" => $_POST["BinNumber"],
            "Amount" => 1,
        );

        if ($this->config->get('payment_ispos_payment_test_mode') == "ON") {
            $endPointUrl = "https://apitest.isyerimpos.com/v1/" . "getInstallments";
        } else {
            $endPointUrl = "https://api.isyerimpos.com/v1/" . "getInstallments";
        }

        $merchantId = $this->config->get('payment_ispos_payment_merchant_id');
        $userId = $this->config->get('payment_ispos_payment_user_id');
        $apiKey = $this->config->get('payment_ispos_payment_api_key');

        $response = $this->curlPostExt(json_encode($arrayToRequest), $endPointUrl, true, $merchantId, $userId, $apiKey);
        print_r($response);
    }

    public function getSiteUrl()
    {
        if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) {
            $site_url = is_null($this->config->get('config_ssl')) ? HTTPS_SERVER : $this->config->get('config_ssl');
        } else {
            $site_url = is_null($this->config->get('config_url')) ? HTTP_SERVER : $this->config->get('config_url');
        }
        return $site_url;
    }

    public function getServerConnectionSlug()
    {
        if (!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] !== 'off' || $_SERVER['SERVER_PORT'] == 443) {
            $connection = 'SSL';
        } else {
            $connection = 'NONSSL';
        }

        return $connection;
    }

    private function curlPostExt($data = null, $url, $json = false, $merchantId, $userId, $apiKey)
    {
        $ch = curl_init(); // initialize curl handle
        curl_setopt($ch, CURLOPT_URL, $url); // set url to post to
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1); // return into a variable

        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_TIMEOUT, 30); // times out after 4s
        curl_setopt($ch, CURLOPT_POST, 1); // set POST method
        if ($data !== null) {
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data); // add POST fields
        }
        $headers = array(
            "MerchantId:  $merchantId",
            "UserId:  $userId",
            "ApiKey:  $apiKey",
            "Content-Type: application/json",
        );
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

        if ($result = curl_exec($ch)) { // run the whole process
            curl_close($ch);

            return $result;
        }
    }
    private function _getCurrencySymbol($currencyCode)
    {
        $currencySymbol = $this->currency->getSymbolLeft($currencyCode);
        if ($currencySymbol == '') {
            $currencySymbol = $this->currency->getSymbolRight($currencyCode);
        } else if ($currencySymbol == '') {
            $currencySymbol = $currencyCode;
        }
        return $currencySymbol;
    }

    public function get_the_user_ip()
    {
        if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            //check ip from share internet
            $ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            //to check ip is pass from proxy
            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } else {
            $ip = $_SERVER['REMOTE_ADDR'];
        }
        return $ip;
    }
    public function replaceSpace($veri)
    {
        $veri = str_replace("/s+/", "", $veri);
        $veri = str_replace(" ", "", $veri);
        $veri = str_replace(" ", "", $veri);
        $veri = str_replace(" ", "", $veri);
        $veri = str_replace("/s/g", "", $veri);
        $veri = str_replace("/s+/g", "", $veri);
        $veri = trim($veri);
        return $veri;
    }
    public function priceParser($price)
    {
        $price = number_format($price, 2, '.', '');

        return $price;
    }

}