<?php
error_reporting(0);
class KahveDigitalIspos
{

    const max_installment = 12;

    public static function getAvailablePrograms()
    {
        return array(
            'axess' => array('name' => 'Axess', 'bank' => 'Akbank A.Ş.', 'installments' => true),
            'world' => array('name' => 'WordCard', 'bank' => 'Yapı Kredi Bankası', 'installments' => true),
            'bonus' => array('name' => 'BonusCard', 'bank' => 'Garanti Bankası A.Ş.', 'installments' => true),
            'cardfinans' => array('name' => 'CardFinans', 'bank' => 'FinansBank A.Ş.', 'installments' => true),
            'maximum' => array('name' => 'Maximum', 'bank' => 'T.C. İş Bankası', 'installments' => true),
            'paraf' => array('name' => 'Paraf', 'bank' => 'Halk Bankası', 'installments' => true),
            'combo' => array('name' => 'Kart Combo', 'bank' => 'Ziraat Bankası', 'installments' => true),
            //'kuveyt' => array('name' => 'Sağlam Kart', 'bank' => 'KuveytTürk', 'installments' => true),
            // 'amex' => array('name' => 'Amex', 'bank' => 'Amerikan Express', 'installments' => true),
        );
    }

    public static function setRatesFromPost($posted_data)
    {
        $banks = KahveDigitalIspos::getAvailablePrograms();
        $return = array();
        foreach ($banks as $k => $v) {
            $return[$k] = array();
            for ($i = 1; $i <= self::max_installment; $i++) {
                $return[$k]['installments'][$i]['value'] = isset($posted_data[$k]['installments'][$i]['value']) ? ((float) $posted_data[$k]['installments'][$i]['value']) : 0.0;
                $return[$k]['installments'][$i]['active'] = isset($posted_data[$k]['installments'][$i]['active']) ? ((int) $posted_data[$k]['installments'][$i]['active']) : 0;
            }
        }
        return $return;
    }

    public static function setRatesDefault()
    {
        $banks = KahveDigitalIspos::getAvailablePrograms();
        $return = array();
        foreach ($banks as $k => $v) {
            $return[$k] = array('active' => 0);
            for ($i = 1; $i <= self::max_installment; $i++) {
                $return[$k]['installments'][$i]['value'] = (float) (1 + $i + ($i / 5) + 0.1);
                $return[$k]['installments'][$i]['active'] = $v['installments'];
                if ($i == 1) {
                    $return[$k]['installments'][$i]['value'] = 0.00;
                    $return[$k]['installments'][$i]['active'] = 0;
                }
            }
        }

        return $return;

    }

    public static function register_all_ins()
    {
        if (isset($_POST['payment_ispos_payment_rates'])) {
            update_option('payment_ispos_payment_rates', KahveDigitalIspos::setRatesFromPost($_POST['payment_ispos_payment_rates']));
        }

    }

    public static function createRatesUpdateForm($rates)
    {
        $ispos_url = HTTP_CATALOG . 'catalog/view/theme/default/image/ispos_payment/';
        $return = '<table class="kahvedigital_ispos_table table">'
            . '<thead>'
            . '<tr><th>Banka</th><th>Durum</th>';
        for ($i = 1; $i <= self::max_installment; $i++) {
            $return .= '<th>' . $i . ' taksit</th>';
        }
        $return .= '</tr></thead><tbody>';

        $banks = KahveDigitalIspos::getAvailablePrograms();
        foreach ($banks as $k => $v) {
            $return .= '<tr>'
                . '<th><img src="' . HTTP_CATALOG . 'catalog/view/theme/default/image/ispos_payment/' . $k . '.svg" width="105px"></th>'
                . '<th><select  name="payment_ispos_payment_rates[' . $k . '][active]" >'
                . '<option value="1">Aktif</option>'
                . '<option value="0" ' . ((int) $rates[$k]['active'] == 0 ? 'selected="selected"' : '') . '>Pasif</option>'
                . '</select></th>';
            for ($i = 1; $i <= self::max_installment; $i++) {
                $return .= '<td>'
                    . ' <input type="checkbox"  name="payment_ispos_payment_rates[' . $k . '][installments][' . $i . '][active]" '
                    . ' value="1" ' . ((int) $rates[$k]['installments'][$i]['active'] == 1 ? 'checked="checked"' : '') . '/>'
                    . '<input type="number" step="0.01" maxlength="4" size="4" style="width:60px" '
                    . ((int) $rates[$k]['installments'][$i]['active'] == 0 ? 'disabled="disabled"' : '')
                    . ' value="' . ((float) $rates[$k]['installments'][$i]['value']) . '"'
                    . ' name="payment_ispos_payment_rates[' . $k . '][installments][' . $i . '][value]"/></td>';
            }
            $return .= '</tr>';
        }
        $return .= '</tbody></table>';
        return $return;
    }

    public static function calculatePrices($price, $rates)
    {
        $banks = KahveDigitalIspos::getAvailablePrograms();
        $return = array();
        foreach ($banks as $k => $v) {
            if ($v['installments'] == false) {
                continue;
            }
            $return[$k] = array('active' => $rates[$k]['active']);
            for ($i = 1; $i <= self::max_installment; $i++) {
                $return[$k]['installments'][$i] = array(
                    'active' => $rates[$k]['installments'][$i]['active'],
                    'total' => number_format((((100 + $rates[$k]['installments'][$i]['value']) * $price) / 100), 2, '.', ''),
                    'monthly' => number_format((((100 + $rates[$k]['installments'][$i]['value']) * $price) / 100) / $i, 2, '.', ''),
                );
            }
        }
        return $return;

    }

    public function getRotatedRates($price, $rates)
    {
        $prices = KahveDigitalIspos::calculatePrices($price, $rates);
        for ($i = 1; $i <= self::max_installment; $i++) {

        }
    }

    public static function createInstallmentsForm($price, $rates)
    {

        $ispos_url = HTTP_CATALOG . 'catalog/view/theme/default/image/ispos_payment/';

        $prices = KahveDigitalIspos::calculatePrices($price, $rates);
        $return = '<table class="kahvedigital_ispos_table table installments">'
            . '<thead>'
            . '<tr><th>Banka</th>';
        for ($i = 1; $i <= self::max_installment; $i++) {
            $return .= '<th>' . $i . ' taksit</th>';
        }
        $return .= '</tr></thead><tbody>';

        $banks = KahveDigitalIspos::getAvailablePrograms();
        foreach ($banks as $k => $v) {
            $return .= '<tr>'
                . '<th><img src="' . $ispos_url . 'img/' . $k . '.svg"></th>';
            for ($i = 1; $i <= self::max_installment; $i++) {
                $return .= '<td><input type="number" step="0.001" maxlength="4" size="4" '
                    . ' value="' . ((float) $rates[$k]['installments'][$i]) . '"'
                    . ' name="payment_ispos_payment_rates[' . $k . '][installments][' . $i . ']"/></td>';
            }
            $return .= '</tr>';
        }
        $return .= '</tbody></table>';
        return $return;
    }

    public static function getProductInstallments($price, $rates)
    {
        $prices = KahveDigitalIspos::calculatePrices($price, $rates);
        $banks = KahveDigitalIspos::getAvailablePrograms();
        $return = '<style>

           .ispos-rates-table {      border-spacing: 0;      border-collapse: collapse;      width: 100%;   }
           .ispos-rates-table * {      font-family: "Helvetica Neue",Helvetica,Arial,sans-serif!important;   }
           .ispos-rates-table-with-bg img{      width: 64px;   }
           .ispos-rates-table-with-bg {      color: #111;      background: #f8f8f8;      border: 1px solid #e3e3e3;   }
           .ispos-rates-table td.axess{    background-color:#e2b631;    color:#fff;   }
           .ispos-rates-table td.maximum{       background-color:#f52295;       color:#fff;   }
           .ispos-rates-table td.cardfinans{       background-color: #2d5fc2;       color:#fff;   }
           .ispos-rates-table td.world{       background-color: #6f6b99;       color:#fff;   }
           .ispos-rates-table td.bonus{       background-color: #479279;       color:#fff;   }
           .ispos-rates-table td{      padding: 5px 10px;      text-align: center;   }
           .ispos-amount {      font-size: 13px;      font-weight: 700;      line-height: 20px;   }
           .ispos-rates-table td span {      display: inline-block;      width: 100%;      text-align: center;   }
           .ispos-rates-table
           .ispos-total-amount {      font-size: 11px;      font-weight: 400;      line-height: 20px;   }
           .ispos-rates-table td {      border: 1px dashed #d6d6d6;   }
           .ispos-rates-table-with-bg {      font-size: 13px!important;   }
                </style>

                <table  style="width: 100%;" class="ispos-rates-table"> <tbody>   <tr style="height:50px;">  <th>Taksit</th>    ';
        foreach ($banks as $k => $v) {
            $return .= '	<th class="ispos-rates-table-with-bg">
                   <img src="catalog/view/theme/default/image/ispos_payment/' . $k . '.svg">	 </th> ';
        }
        $return .= '</tr>
             <tr>
             </tr><tr> ';

        for ($ins = 1; $ins < self::max_installment; $ins++) {
            if ($ins == 1) {
                $return .= '<td class="ispos-rates-table-with-bg" style="height:50px;"> Peşin </td> ';
            } else {

                $return .= '<td class="ispos-rates-table-with-bg" style="height:50px;"> ' . $ins . ' Taksit </td> ';
            }
            foreach ($banks as $k => $v) {

                if ($ins == 1) {
                    $return .= ' <td class="' . $k . '">  <span class="ispos-amount"> ' . $prices[$k]['installments'][$ins]['total'] . '  TL</span> </td>   ';
                } else {

                    $return .= ' <td class="' . $k . '">  <span class="ispos-amount"> ' . $prices[$k]['installments'][$ins]['monthly'] . ' x ' . $ins . ' </span><span class="ispos-total-amount"> TOPLAM ' . $prices{$k}['installments']{ $ins}['total'] . ' TL </span> </td>   ';
                }
            }

            $return .= '</tr>';
        }
        $return .= '<tbody></table>';

        return $return;
    }
}
