<?php
if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly
}

$ispos_url = plugins_url('/', dirname(__FILE__));
?>
<script src="//ajax.googleapis.com/ajax/libs/jquery/1.10.1/jquery.min.js"></script>
<script src="<?php echo $ispos_url ?>/assets/js/card.js"></script>
<?php if ($error_message) {?>
<div class="row">
    <ul class="woocommerce-error" id="errDiv">
        <li>
            <?php echo __('Payment Error.', 'ispos-woocommerce') ?>
            <b><?php echo $error_message; ?></b><br />
            <?php echo __('Please check the form and try again.', 'ispos-woocommerce') ?>
        </li>
    </ul>
</div>
<?php }?>
<link rel="stylesheet" type="text/css" href="<?php echo $ispos_url ?>assets/css/ispos.css">
<div class="row">
    <div class="col-xs-12">
        <div id="ispos-form" class="isposform">
            <div class="tum">
                <h3 class="odemeform-baslik"><?php echo __('Payment Form', 'ispos-woocommerce') ?></h3>
                <div class="hepsi">
                    <div class="demo-container">
                        <div class="info-window cvc ">
                            <div class="arrow-info"></div>
                            <div class="cvc-info"><img src="<?php echo $ispos_url ?>assets/img/cvc-help.png"></div>
                        </div>
                        <div class="form-group active ispos">
                            <form method="POST" id="ispospostform" action="">
                                <div class="isposname isposfull">
                                    <input class="c-card card-name"
                                        placeholder="<?php echo __('Name on Card', 'ispos-woocommerce'); ?>" type="text"
                                        required oninvalid="this.setCustomValidity('Kart sahibinin adını yazınız.')"
                                        oninput="setCustomValidity('')" name="card-name" id="card-name">
                                </div>
                                <input value="<?php echo $orderid ?>" name="order_id" type="hidden">
                                <div class="isposcard isposorta">
                                    <i class="isposcardicon"></i>
                                    <input id="isposcardnumber" class="c-card cardnumber"
                                        placeholder="<?php echo __('Card Number', 'ispos-woocommerce'); ?>" required
                                        oninvalid="this.setCustomValidity('Kartın üzerindeki 16 haneli numarayı giriniz.')"
                                        oninput="setCustomValidity('')" type="tel" name="number">
                                </div>
                                <div class="isposleft isposexpry">
                                    <input class="c-date c-card"
                                        placeholder="<?php echo __('MM/YY', 'ispos-woocommerce'); ?>" type="tel"
                                        maxlength="7" required
                                        oninvalid="this.setCustomValidity('Kartın son kullanma tarihini giriniz')"
                                        oninput="setCustomValidity('')" name="expiry">
                                </div>
                                <div class="isposright isposcvc">
                                    <input class="card-cvc c-card" placeholder="CVC" required type="number"
                                        oninvalid="this.setCustomValidity('Kartın arkasındaki 3 ya da 4 basamaklı sayıyı giriniz')"
                                        oninput="setCustomValidity('')" name="cvc">
                                    <div class="ispos-i-icon"><img
                                            src="<?php echo $ispos_url ?>assets/img/icons/info.png" width="14px"> </div>
                                </div>
                        </div>
                    </div>
                    <div class="tekcekim-container ">
                        <div class="tekcekim">
                            <li class="taksit-li " for="s-option">
                                <input type="radio" id="s-option" name="ispostotal" value="<?php echo $showtotal ?>"
                                    checked class="option-input taksitradio radio ">
                                <label for="s-option">Tek Çekim</label>
                                <div class="taksit-fiyat"> <?php echo $showtotal; ?></div>
                                <div class="check">
                                    <div class="inside"></div>
                                </div>
                            </li>
                            <div class="taksit-secenek">
                                <?php if ($installments_mode == 'on') {?>
                                <h3 class="taksit-secenekleri"><?php echo __('All Installment', 'ispos-woocommerce'); ?>
                                </h3>
                                <div class="logolar-ispos">
                                    <?php foreach ($rates as $bank => $rate) {?>
                                    <div class="ispos-banka-logo <?php echo $bank; ?>-logo"><img
                                            src="<?php echo $ispos_url ?>assets/img/<?php echo $bank ?>.svg"></img>
                                    </div>
                                    <?php }?>
                                </div>
                                <?php }?>
                            </div>
                        </div>
                    </div>
                    <?php if ($installments_mode == 'on') {?>
                    <div class="taksit-container ">
                        <?php foreach ($rates as $bank => $rate) {?>
                        <div class="<?php echo $bank; ?>">
                            <div class="taksit-title "><img
                                    src="<?php echo $ispos_url ?>assets/img/<?php echo $bank ?>.svg"></div>
                            <?php for ($ins = 1; $ins < 13; $ins++) {?>
                            <?php foreach ($rates as $banks => $rate) {?>
                            <?php if ($bank == $banks) {?>
                            <?php if ($rates[$banks]['installments'][$ins]['active'] == 1) {?>
                            <li class="taksit-li isposorta">
                                <input type="radio" id="s-option_<?php echo $banks; ?>_<?php echo $ins; ?>"
                                    name="ispostotal[<?php echo $banks; ?>][<?php echo $ins; ?>]"
                                    value="<?php echo $rates[$banks]['installments'][$ins]['total']; ?>"
                                    class="option-input  taksitradio radio">
                                <label for="s-option2"><?php echo $ins ?>
                                    <?php echo __('Installment', 'ispos-woocommerce'); ?></label>
                                <div class="taksit-fiyat"> <?php echo $rates[$banks]['installments'][$ins]['total']; ?>
                                    / <?php echo $rates[$banks]['installments'][$ins]['monthly']; ?> </div>
                                <div class="check">
                                    <div class="inside"></div>
                                </div>
                            </li>
                            <?php }?>
                            <?php }?>
                            <?php }?>
                            <?php }?>
                        </div>
                        <?php }?>
                    </div>
                    <?php }?>
                    <button type="submit" class="isposode" style=""><span
                            class="isposOdemeTutar"><?php echo $showtotal; ?></span><span class="currency">
                            <?php echo $currency; ?></span><span class="isposOdemeText">
                            <?php echo __('Pay', 'ispos-woocommerce'); ?></span></button>
                    </form>
                </div>
            </div>
            <div class="card-wrapper" style="margin-left:5px;"></div>
        </div>
    </div>
</div>
<script>
var theme = "<?php echo $ispos_url ?>";
var taksit = "<?php echo $installments_mode ?>";
</script>
<script type="text/javascript">
new Card({
    form: document.querySelector('.hepsi'),
    container: '.card-wrapper',
    formSelectors: {
        nameInput: 'input#card-name'
    },
});
$(document).ready(function() {
    $('input[type=radio][name=ispostotal]').change(function() {
        $('.isposOdemeTutar').text(this.value);
        $('.currency').text(" <?php echo $currency; ?>");
    });
});
if (taksit == 'on') {
    $(document).ready(function() {
        cardshow(0);
        $(".maximum-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".maximum").show();
            $("#s-option_maximum_1").prop('checked', true);
        });
        $(".cardfinans-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".cardfinans").show();
            $("#s-option_cardfinans_1").prop('checked', true);
        });
        $(".axess-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".axess").show();
            $("#s-option_axess_1").prop('checked', true);
        });
        $(".paraf-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".paraf").show();
            $("#s-option_paraf_1").prop('checked', true);
        });
        $(".bonus-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".bonus").show();
            $("#s-option_bonus_1").prop('checked', true);
        });
        $(".world-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".world").show();
            $("#s-option_world_1").prop('checked', true);
        });
        $(".combo-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".combo").show();
            $("#s-option_combo_1").prop('checked', true);
        });
        $(".amex-logo").click(function() {
            cardshow(0);
            $(".taksit-container").show();
            $(".amex").show();
            $("#s-option_amex_1").prop('checked', true);
        });
        $(".taksit-li").click(function() {
            $(".taksit-li").find('input[type="radio"]').removeAttr('checked');
            $(this).find('input[type="radio"]').prop('checked', true);
            var price = $(this).find('input[type="radio"]').val();
            $('.isposOdemeTutar').text(price);
        });

        function cardshow(bankcode) {
            if (bankcode == '0') {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
            } else if ((bankcode == 62) || (bankcode == 59) || (bankcode == 32) || (bankcode == 99) || (
                    bankcode == 124) || (bankcode == 134) || (bankcode == 206)) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.bonus').show();
                $("#s-option_bonus_1").prop('checked', true);
            } else if ((bankcode == 46) || (bankcode == 92)) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.axess').show();
                $("#s-option_axess_1").prop('checked', true);
            } else if ((bankcode == 64)) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.maximum').show();
                $("#s-option_maximum_1").prop('checked', true);
            } else if ((bankcode == 15) || (bankcode == 67) || (bankcode == 135) || (bankcode == 203)) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.world').show();
                $("#s-option_world_1").prop('checked', true);
            } else if (bankcode == 111) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.cardfinans').show();
                $("#s-option_cardfinans_1").prop('checked', true);
            } else if (bankcode == 12) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.paraf').show();
                $("#s-option_paraf_1").prop('checked', true);
            } else if (bankcode == 217 || (bankcode == 10)) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.combo').show();
                $("#s-option_combo_1").prop('checked', true);
            } else if (bankcode == 205) {
                $(".taksit-container").hide();
                $(".taksit-container").children().hide();
                $(".taksit-container").show();
                $('.kuveyt').show();
                $("#s-option_kuveyt_1").prop('checked', true);
            }
        }
        $.ajaxSetup({
            cache: false
        });
        $('#isposcardnumber').keyup(function() {
            var searchField = $('#isposcardnumber').val();
            searchField = searchField.replace(/\s/g, '');
            if (searchField.length < 6) {
                cardshow(0);
                return;
            };
            if (searchField.length > 10)
                return;
            jQuery.ajax({
                type: "POST",
                url: "/ispos-woocommerce/wc-api/ispos/",
                data: {
                    BinNumber: searchField
                },
                success: function(data) {

                    console.log(data);

                    var response = JSON.parse(data);

                    if (response.Content.CardInfo.IsCreditCard == true) {
                        cardshow(response.Content.CardInfo.BankId);
                    }
                },
                error: function(errorThrown) {
                    alert(errorThrown);
                }
            });
        });
    });
}
$(".ispos-i-icon img").hover(function() {
    $(".info-window").toggleClass("info-window-active");
});
$('.c-card').bind('keypress keyup keydown focus', function(e) {
    var ErrorInput = false;
    if ($("input.card-name").hasClass("jp-card-invalid")) {
        ErrorInput = true;
        $("input.card-name").addClass("border");
    }
    if ($("input.cardnumber").hasClass("jp-card-invalid")) {
        ErrorInput = true;
        $("input.cardnumber").addClass("border");
    }
    if ($("input.c-date").hasClass("jp-card-invalid")) {
        ErrorInput = true;
        $("input.c-date").addClass("border");
    }
    if ($("input.card-cvc").hasClass("jp-card-invalid")) {
        ErrorInput = true;
        $("input.card-cvc").addClass("border");
    }
    if (ErrorInput === true) {
        $('.isposode').attr("disabled", true);
        $(".isposode").css("opacity", "0.5");
    } else {
        $("input.card-name").removeClass("border");
        $("input.cardnumber").removeClass("border");
        $("input.c-date").removeClass("border");
        $("input.card-cvc").removeClass("border");
        $('.isposode').attr("disabled", false);
        $(".isposode").css("opacity", "1");
    }
});
</script>